﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics.Controls.Charts;
using System.Collections.Generic;

namespace xamDataChart_CustomTickmarks
{
    public class CustomTickmarkValues : TickmarkValues
    {
        protected double First;
        protected double Last;
        protected DoubleCollection Tickmarks;

        public CustomTickmarkValues()
        {
            // define custom tickmark values
            this.Tickmarks = new DoubleCollection { 0.0, 10.0, 20.0, 30.0, 40.0, 50.0, 60.0, 70.0, 80.0, 90.0, 100.0 };
        }

        public override void Initialize(TickmarkValuesInitializationParameters initializationParameters)
        {
            base.Initialize(initializationParameters);
            // Initialize is overridden in order to store the minimum and maximum values, 
            // which will be later used in the MajorValues() and MinorValues() methods.
            this.First = initializationParameters.VisibleMinimum;
            this.Last = initializationParameters.VisibleMaximum;

        }

        public override System.Collections.Generic.IEnumerable<double> MajorValues()
        {
            List<double> value = new List<double>();
            for (int i = 0; i < Tickmarks.Count; i++)
            {
                if (Tickmarks[i] >= this.First && Tickmarks[i] <= this.Last)
                    value.Add(Tickmarks[i]);
            }

            if (this.Last != Tickmarks[Tickmarks.Count - 1])
                value.Add(this.Last);

            return value;
        }

        public override System.Collections.Generic.IEnumerable<double> MinorValues()
        {
            double start = this.First;
            for (double minorValue = start; minorValue < this.Last; minorValue += 1.0)
            {
                yield return minorValue;
            }
        }
    }
}